#include "validation.h"

using namespace std;

int main(int argc, char **argv) {
    // Set up the input and answer streams.
    ifstream in(argv[1]);
    // std::ifstream ans(argv[2]); // Only for custom checker.
    OutputValidator v(argc, argv);

    int n, ans = 0;
    in >> n;
    vector<vector<int>> vs(n, vector<int>(n));
    for (int y = 0; y < n; y++) {
        for (int x = 0; x < n; x++) {
            in >> vs[y][x];
            ans = max(ans, vs[y][x]);
        }
    }

    // Interactions.
    int queries = 0;
    int maxq = n * n + 100;
    int extraq = n * n * 4 + 1000;
    while(true) {
        auto op = v.read_string("op", 1, 1, "?!");
        v.space();

        if(op == "?") {
            // Answer query.
            queries += 1;
            if(queries > maxq + extraq) {
                v.WA("Used more than ", maxq+extraq, " queries");
            }
            int x = v.read_integer("x", 1, 1000);
            v.space();
            long long y = v.read_integer("y", 1, 1000);
            v.newline();
            if(1 <= x && x <= n && 1 <= y && y <= n) {
                std::cout << vs[y - 1][x - 1] << std::endl;
            } else {
                std::cout << "ArrayIndexOutOfBoundsException" << std::endl;
            }
        } else if(op == "!") {
            int v_ans = v.read_integer("v_ans", ans, ans);
            v.newline();

            if(queries > maxq){
                v.WA("Used ", queries, " queries, limit is ", maxq);
            }
            std::cerr << "Used " << queries << " queries, limit is " << maxq << std::endl;
            break;
        } else {
            v.WA("unknown op ", op);
        }
    }
}
