import java.util.*;
import java.io.*;

public class BrothersPK{
   public static void main (String [] args){
       run();
   }

   static void run(){
      BrothersPK problem = null;
      InputStream is = null;
      try{
         is = System.in;
     
         BufferedReader in = new BufferedReader(new InputStreamReader(is));
         String line = in.readLine();
         Scanner ir = new Scanner(line);
         int cities = ir.nextInt();
         int symbols = ir.nextInt();
         problem = new BrothersPK(cities, symbols);
         for (int k = 1; k <= cities; k++){
            line = in.readLine();
            String [] words = line.split(" ");
            problem.addCity(Integer.parseInt(words[0]), Integer.parseInt(words[1])+ symbols);
         }

         problem.fillTable();
        // problem.dump();
         line = in.readLine();
         int queries = Integer.parseInt(line);
         for (int k = 1; k <= queries; k++){
            line = in.readLine();
            String [] words = line.split(" ");
            int city0 = Integer.parseInt(words[0]);
            int city1 = Integer.parseInt(words[1]);
            System.out.println(problem.distance(city0, city1));
         }
      }
      catch (IOException iox){System.out.println( iox);}

   }

   ///////////////////////////////
   static int INF = 1000;
   int symbols;
   int cityCount = 1;
   int [][] cities;
   int [][] distance;

   public BrothersPK(int citiesIn, int symbols){
      cities = new int [citiesIn+1][2];
      distance = new int [2 * symbols +1][2 * symbols+1];
      this.symbols = symbols;
      makeDistance();
   }
   
   void makeDistance(){
      for (int k = 1; k <= 2 * symbols; k++)
         for (int l = 1; l <= 2 * symbols; l++)
            if(k == l)
               distance[k][l] = 0;
            else
               distance[k][l] = INF;
   }
   
   void addCity(int s1, int s2){
       cities[cityCount++] = new int[]{s1,s2};
       distance[s1][s2] = 1;
       distance[s2][s1] = 1;
   }
   
   void fillTable(){ // Floyd -Warshall
      for (int k = 1; k <= 2 * symbols; k++)
         for (int i = 1; i <= 2 * symbols; i++)
            if (distance[i][k] < INF)
               for (int j = 1; j <= 2 * symbols; j++)
                  if (distance[k][j] < INF){
                     int omweg = distance[i][k] + distance[k][j];
                     if (omweg < distance[i][j]){
                        distance[i][j] = omweg;
                     }
                  }
   }

   int distance(int c1, int c2){
      int d1 = distance[cities[c1][0]][cities[c2][0]];
      int d2 = distance[cities[c1][1]][cities[c2][1]];
      int d = Math.min(d1, d2);
      int d3 = distance[cities[c1][1]][cities[c2][0]];
      d = Math.min(d, d3);
      int d4 = distance[cities[c1][0]][cities[c2][1]];
      d = Math.min(d, d4);
      if (d == INF)
          return -1;
      else
         return d + 1;
   }

   void dump(){
     for (int k = 1; k <= 2 * symbols; k++){
        for (int l = 1; l <= 2 * symbols; l++)
           System.out.print(distance[k][l] + " " );
        System.out.println();
     }

   }
}