import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class MaartenBufferedReader {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenBufferedReader().run(reader);
        }
    }

    public void run(BufferedReader reader) throws IOException {
        String[] firstLine = reader.readLine().split(" ");
        int n = Integer.parseInt(firstLine[0]);
        int s = Integer.parseInt(firstLine[1]);

        int[][] kingdoms = new int[n][2];
        for (int i = 0; i < n; i++) {
            String[] line = reader.readLine().split(" ");
            for (int j = 0; j < 2; j++) {
                kingdoms[i][j] = Integer.parseInt(line[j]) - 1 + j * s;
            }
        }

        int[][] dist = new int[2 * s][2 * s];
        for (int i = 0; i < 2 * s; i++) {
            for (int j = 0; j < 2 * s; j++) {
                dist[i][j] = i == j ? 0 : 3 * s;
            }
        }
        for (int[] k : kingdoms) dist[k[0]][k[1]] = dist[k[1]][k[0]] = 1;

        for (int k = 0; k < 2 * s; k++) {
            for (int i = 0; i < 2 * s; i++) {
                for (int j = 0; j < 2 * s; j++) {
                    dist[i][j] = Math.min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }

        int q = Integer.parseInt(reader.readLine());
        for (int k = 0; k < q; k++) {
            String[] line = reader.readLine().split(" ");
            int[] K = kingdoms[Integer.parseInt(line[0]) - 1];
            int[] L = kingdoms[Integer.parseInt(line[1]) - 1];
            int ans = 3 * s;
            for (int i = 0; i < 2; i++) {
                for (int j = 0; j < 2; j++) {
                    ans = Math.min(ans, dist[K[i]][L[j]]);
                }
            }
            System.out.println(ans == 3 * s ? -1 : ans + 1);
        }
    }
}
