import java.io.*;
import java.util.*;

public class MaartenScanner {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenScanner().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        int n = sc.nextInt(), s = sc.nextInt();

        int[][] kingdoms = new int[n][2];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 2; j++) {
                kingdoms[i][j] = sc.nextInt() - 1 + j * s;
            }
        }

        int[][] dist = new int[2 * s][2 * s];
        for (int i = 0; i < 2 * s; i++) {
            for (int j = 0; j < 2 * s; j++) {
                dist[i][j] = i == j ? 0 : 3 * s;
            }
        }
        for (int[] k : kingdoms) dist[k[0]][k[1]] = dist[k[1]][k[0]] = 1;

        for (int k = 0; k < 2 * s; k++) {
            for (int i = 0; i < 2 * s; i++) {
                for (int j = 0; j < 2 * s; j++) {
                    dist[i][j] = Math.min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }

        int q = sc.nextInt();
        for (int k = 0; k < q; k++) {
            int[] K = kingdoms[sc.nextInt() - 1];
            int[] L = kingdoms[sc.nextInt() - 1];
            int ans = 3 * s;
            for (int i = 0; i < 2; i++) {
                for (int j = 0; j < 2; j++) {
                    ans = Math.min(ans, dist[K[i]][L[j]]);
                }
            }
            System.out.println(ans == 3 * s ? -1 : ans + 1);
        }
    }
}
