#include <iostream>
#include <vector>

using namespace std;

constexpr int S  = 400;
constexpr int SS = S * 2;
int INF          = 1e9;
int adj[SS][SS];
void floyd_warshall(int V) {
	for(int b = 0; b < V; ++b)
		for(int a = 0; a < V; ++a)
			for(int c = 0; c < V; ++c)
				if(adj[a][b] != INF && adj[b][c] != INF)
					adj[a][c] = min(adj[a][c], adj[a][b] + adj[b][c]);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, s;
	cin >> n >> s;

	for(auto& x : adj) fill(begin(x), end(x), INF);
	for(int i = 0; i < 2 * s; ++i) adj[i][i] = 0;

	// left: 0..s
	// right: s..2s
	vector<pair<int, int>> ps(n);
	for(auto& p : ps) {
		cin >> p.first >> p.second;
		--p.first;
		--p.second;
		p.second += s;
		adj[p.first][p.second] = 1;
		adj[p.second][p.first] = 1;
	}

	floyd_warshall(2 * s);

	int q;
	cin >> q;
	for(int i = 0; i < q; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		int d = INF;
		d     = min(d, adj[ps[x].first][ps[y].first]);
		d     = min(d, adj[ps[x].first][ps[y].second]);
		d     = min(d, adj[ps[x].second][ps[y].first]);
		d     = min(d, adj[ps[x].second][ps[y].second]);
		cout << (d == INF ? -1 : d + 1) << endl;
	}
}
