#!/usr/bin/env python3
n, s = map(int, input().split())
kingdoms = [0, *((a, b + s) for a, b in (map(int, input().split()) for _ in range(n)))]

neighs: list[list[int]] = [[] for _ in range(2 * s + 1)]
for a, b in kingdoms[1:]:
    neighs[a].append(b)
    neighs[b].append(a)
# print(*neighs, sep="\n")

dist = [[3 * s] * (2 * s + 1) for _ in range(2 * s + 1)]
for a in range(1, 2 * s + 1):
    dist[a][a], d, seen, queue = 0, 0, set(), [a]
    while queue:
        d, old_queue, queue = d + 1, queue, []
        for curr in old_queue:
            seen.add(curr)
            for neigh in neighs[curr]:
                if neigh not in seen:
                    queue.append(neigh)
                    dist[a][neigh] = d
# print(*dist, sep="\n")

for _ in range(int(input())):
    (a, b), (c, d) = (kingdoms[int(i)] for i in input().split())
    print(-1 if (ans := min(dist[a][c], dist[a][d], dist[b][c], dist[b][d])) == 3 * s else ans + 1)
